/* Shoot Redux: Marifriski Space Warrior */

/* Anju, eres un picn de cojones :D
   Lo bueno es que ya haca falta otro minigame,
   y asn voy refinando las rutinas de mi biblioteca
   de juegos orientada a carcter :D
*/

/* 
	De fondo, un scroller
	=====================
	
	Tenemos tres tipos de estrellas: 
	
	* Las gordotas que ocupan un carcter bajan en cada frame.
	* Las menos gordotas de 2x2 cada dos frames.
	* Las menos gordotas 2 de 2x2 cada cuatro frames.
	
	En total definimos pongamos #define NUM_MOVILES = 60 y hacemos los 3 tercios.
	
	Se borran poniendo espacios.
	
	Para que no se quede nada feo, el orden de dibujo ser:
	
	1.- Escrol.
	2.- Bichos.
	3.- La nave guapa.
	4.- Balas y cataplofs.
*/

/* 
	Todo por partculas
	===================
	
	Lo voy a hacer todo por partculas, incluso el scroller de fondo,
	y as me quito de problemas e idicioteces, y luego lo puedo
	modificar todo si me gusta poco o nada.
	
	Estos son los tipos de partculas (id):
	
	1	Estrella 1, velocidad 8 (para que baje en cada frame)
	2 	Estrella 2, velocidad 4
	3	Estrella 3, velocidad 2
	4	Malvadoz
	5 	Explosion

	Y los manejo todos desde el handler de partculas y a ju.
*/

/*
	Tiestos:
	========
	
	titlescr.bin -> 1314 bytes
	
	
	Mem_map:
	
	29901	1248	musica, programada con orfeus sin tener auriculares (a sordas! :D)
	31149	1314	titlescr.bin
	32463	305		uncrunch.bin
	32768			frisky.bin
*/

/* 
	Decisiones de diseo:
	=====================
	
	dif es dificultad.
	
	- Un visil cae cada 2*(9-dif) veces. Si dif = 9 cae siempre, esto es.
	- Un visil no da puntos al romperse, pero saca 3 mierdos nuevos.
	- Un mierdo da dif+1 puntos.
*/

// Pragma:

#pragma output STACKPTR=61440

// Includes:

#include <spritepack.h>
#include "externs.h"

// Defines:

#define AD_FREE			58000
#define WYZ_INTERRUPT	24520
#define WYZ_LOAD		24563
#define WYZ_INTERR		25266
#define WYZ_PLAY_SOUND	24548
#define PUCRUNCH		32463
#define TITLESCR		31149
#define MUSICA			29901
#define MAX_PARTICLES 	64

// Struct/types:

extern struct sp_Rect *sp_ClipStruct;
extern char asm_number[1];
extern char *Rand8;
struct sp_Rect spritesClipValues;
struct sp_Rect *spritesClip;
struct sp_UDK keys;
struct sp_PSS ps;         // a print string struct used by sp_PrintString

typedef struct {
	uchar x, y;
	char mx, my;
	uchar status;
	uchar score;
	uchar *current_frame, *next_frame;
} MOVILES;

typedef struct {
	unsigned char x;
	unsigned char y;
	char vx;
	char vy;
	char tipo;
	char vida;
} PARTICLE;

typedef struct {
	char x, xx;
	char y;
	unsigned char status;
	unsigned char lives;
	unsigned int score;
	unsigned char total;
} FRISKY;

// Extern data:

#asm
	LIB SPCClipStruct
._sp_ClipStruct
	defw SPCClipStruct
._asm_number 
	defb 0
#endasm

// Globals:

char play = 0;
FRISKY frisky;	// Esta linea me hace una jart de risa quillo :D
FRISKY visil;	// Mi hermano de chico deca "visil" en vez de misil.
MOVILES malo;
PARTICLE particulas [MAX_PARTICLES];
uchar cota;
uchar flipflop = 0;
char globaldif = 3;
unsigned char sound1[] = {100,50,0,0,0,0,4,216,31,0,0,10,10,9};
unsigned char sound2[] = {250,250,0,0,0,0,15,248,31,0,0,10,10,0};
unsigned char sound3[] = {10,10,0,0,0,0,29,216,31,0,0,4,4,0};
unsigned char sound4[] = {10,100,0,0,0,0,15,248,31,0,0,50,50,0};
unsigned char sound5[] = {15,1,0,0,0,0,15,248,31,0,0,50,50,0};
unsigned char *sounds[] = {sound1, sound2, sound3, sound4, sound5};
unsigned int hiscore = 0;

// Controlamos el nmero de cada tipo de estrellas de fondo dependiendo de la
// dificultad seleccionada: 

char n_stars_1[] = {3, 3, 3, 3, 3, 3, 2, 2, 2, 2};
char n_stars_2[] = {3, 3, 3, 3, 3, 2, 2, 2, 2, 2};
char n_stars_3[] = {9, 8, 7, 7, 6, 6, 6, 5, 4, 3};

#asm
defw 0                        /* two free bytes before start of a hook */
#endasm
void musicISR(void)
{
	if (play)
	{
	#asm
		push af
		push bc
		push de
		push hl
		push ix
		
		call WYZ_INTERRUPT
		
		pop ix
		pop hl
		pop de
		pop bc
		pop af
	#endasm
	}
}

void *my_malloc(uint bytes) {
   return sp_BlockAlloc(0);
}

void *u_malloc = my_malloc;

void *u_free = sp_FreeBlock;

void init_particles () {
	unsigned char i;	
	
	for (i = 0; i < MAX_PARTICLES; i ++) {
		particulas [i].tipo = 0;
	}
}

void add_particle (unsigned char x, unsigned char y, char vx, char vy, char tipo, char vida) {
	unsigned char i;
	
	for (i = 0; i < MAX_PARTICLES; i ++) {
		if (particulas [i].tipo == 0) {
			particulas [i].x = (x>>3)<<3;	// Ajuste a celda de carcter.
			particulas [i].y = (y>>3)<<3;
			particulas [i].vx = vx;
			particulas [i].vy = vy;
			particulas [i].tipo = tipo;
			particulas [i].vida = vida;
			break;
		}
	}
}

void destroy_particle (unsigned char n) {
	particulas [n].tipo = 0;
}

void wyz_play_sound (char fx_number) {
	asm_number[0] = fx_number;
	#asm
		ld a, (_asm_number)
		call WYZ_PLAY_SOUND
	#endasm
}

void wyz_play_song (char song_number) {
	play = 0;
	asm_number[0] = song_number;
	#asm
		ld a, (_asm_number)
		call WYZ_LOAD
	#endasm
	play = 1;
}

void kjjjj () {
	// Original de Daniel de la Cruz
	// Publicado en MH #197, pg 24.
	
	#asm
		ld	c, 1
	.kjjjj_bucle
		ld 	a, 255
		inc	c
		ld	b, 198
	.kjjjj_stop
		djnz kjjjj_stop
		outi
		cp	c
		jr	nz, kjjjj_bucle
	#endasm	
}

void sound_collection () {

	// 48K Sound effects code by Digital Prawn
	// kindly posted on the WOS forums.
	// Thanks, mate!
	
	#asm
	.CurrLevelPaperColour		defb 	0
	
	.PlayDotSFX					ld 		de,30
	    						ld 		hl,30
	    						ld 		bc,$ffff
	    						call	PlaySFX
	    						ret
	
	.PlayPowerPillSFX			ld 		b,1
	.PlayPowerPillSFXLoop1		push	bc
	    						ld 		de,60
	    						ld		hl,60
	    						ld		bc,$ffff
	    						call	PlaySFX
	    						pop 	bc
	    						djnz 	PlayPowerPillSFXLoop1
	    						ret
	
	;Play Sound Effects
	;de holds number of cycles to play
	;hl holds the length of each cycle
	;bc holds the amount to change the length by on each iteration 				
	    						
	.PlaySFX					di
	.PlaySFXLoop1				ld 		a,(CurrLevelPaperColour) 	; flip the speaker
	    						xor 	@00010000
	    						out		($fe),a
	    						push 	hl							; hold amplitude for hl cycles
	.PlaySFXLoop2				dec 	hl
								ld 		a,h
								or 		l
								jr 		nz,PlaySFXLoop2
								pop 	hl
								ld 		a,(CurrLevelPaperColour)	; flip the speaker back
	    						out 	($fe),a   
	    						push 	hl							; hold amplitude for hl cycles
	.PlaySFXLoop3				dec 	hl
	    						ld 		a,h
	    						or 		l
	    						jr 		nz,PlaySFXLoop3
	    						pop 	hl
	    						add 	hl,bc 						; vary the cycle length if bc is non-zero
	    						dec 	de
	    						ld 		a,d
	    						or 		e
	    						jr 		nz,PlaySFXLoop1  			; do it 'de' times
	    						ei
	    						ret
	    
	#endasm
}

void fade_out () { 
	/* El segundo programa de más de 5 lineas en Z80 ASM de na_th_an */ 
	/* Optimizado por Metalbrain */ 
	/* Esto "oscurece" un paso la pantalla. Llamado 8 veces la dejará en negro */ 
	unsigned char i;
	
	for (i = 0; i < 8; i ++) {	
		#asm 
			ld  e, 3            ; 3 tercios 
			ld  hl, 22528       ; aquí empiezan los atributos 
			halt                ; esperamos retrazo. 
		.fade_out_bucle 
			ld  a, (hl)         ; nos traemos el atributo actual 
			
			ld  d, a            ; tomar atributo 
			and 7               ; aislar la tinta 
			jr  z, ink_done     ; si vale 0, no se decrementa 
			dec a               ; decrementamos tinta 
		.ink_done 
			ld  b, a            ; en b tenemos ahora la tinta ya procesada. 
			
			ld  a, d            ; tomar atributo 
			and 56              ; aislar el papel, sin modificar su posición en el byte 
			jr  z, paper_done   ; si vale 0, no se decrementa 
			sub 8               ; decrementamos papel restando 8 
		.paper_done 
			ld  c, a            ; en c tenemos ahora el papel ya procesado. 
			ld  a, d 
			and 192             ; nos quedamos con bits 6 y 7 (BRIGHT y FLASH) 
			or  c               ; añadimos paper 
			or  b               ; e ink, con lo que recompuesto el atributo 
			ld  (hl),a          ; lo escribimos, 
			inc  l              ; e incrementamos el puntero. 
			jr   nz, fade_out_bucle ; continuamos hasta acabar el tercio (cuando L valga 0) 
			inc  h              ; siguiente tercio 
			dec  e 
			jr   nz, fade_out_bucle ; repetir las 3 veces 
		#endasm 
	}
}

uchar rand () {
	uchar res;
	
	#asm
	._Rand8	ld	a,9		; Seed is usually 0
			ld	b,a
			add	a,a
			add	a,a
			add	a,b
			inc	a		; another possibility is ADD A,7
			ld (_Rand8+1),a
			ld (_asm_number), a
	#endasm

	res = asm_number [0];

	return res;
}

void my_play_sound (int n) {
	sp_outp (65533, 4);
	sp_outp (49149, *(sounds[n]));
	sp_outp (65533, 5);
	sp_outp (49149, *(sounds[n] + 1));
	sp_outp (65533, 6);
	sp_outp (49149, *(sounds[n] + 6));
	sp_outp (65533, 7);
	sp_outp (49149, *(sounds[n] + 7));
	sp_outp (65533, 10);
	sp_outp (49149, *(sounds[n] + 8));
	sp_outp (65533, 11);
	sp_outp (49149, *(sounds[n] + 11));
	sp_outp (65533, 12);
	sp_outp (49149, *(sounds[n] + 12));
	sp_outp (65533, 13);
	sp_outp (49149, *(sounds[n] + 13));
}

int sgn (int x) {
	if (x < 0)
		return -1;
	else if (x = 0)
		return 0;
	else
		return 1;
}

unsigned int abs (int x) {
	if (x >= 0)
		return x;
	else
		return -x;
}

unsigned char attr (char x, char y) {
	char *res = (char *) (22528 + x + (y << 5));
	return (*res & 63);
}

void draw_tile (char x, char y, char c, char tile) {
	sp_PrintAtInv (y, x, c, tile);
	sp_PrintAtInv (y, 1 + x, c, tile + 1);
	sp_PrintAtInv (1 + y, x, c, tile + 2);
	sp_PrintAtInv (1 + y, 1 + x, c, tile + 3);
}

void blackout_everything () {
	unsigned char *origin;

	origin = (unsigned char *) 22528;
	while (origin < 23296)
	{
		*origin = 0;
		origin ++;
	}
}

void uncrunch (int address) {
	unsigned char *origin;
	unsigned char *destiny;
	unsigned char msb, lsb;

	origin = (unsigned char *) PUCRUNCH;
	destiny = (unsigned char *) PUCRUNCH + 2;

	msb = address >> 8;
	lsb = address & 255;
	
	*origin = lsb;
	origin ++;
	*origin = msb;

	*destiny = 0;
	destiny ++;
	*destiny = 64;

	// Antes de llamar a pucrunch, tintamos la pantalla de negro
	// para que no se vea tan feo:

	blackout_everything ();

	#asm
		di
		call PUCRUNCH + 4
		ei
	#endasm
}


void draw_energy (void) {
	sp_PrintAtInv (22, 28, 7, 16 + frisky.lives / 10);
	sp_PrintAtInv (22, 29, 7, 16 + frisky.lives % 10);
}

void draw_score (void) {
	sp_PrintAtInv (22, 2, 7, 16 + frisky.score / 1000);
	sp_PrintAtInv (22, 3, 7, 16 + (frisky.score % 1000) / 100);
	sp_PrintAtInv (22, 4, 7, 16 + (frisky.score % 100) / 10);
	sp_PrintAtInv (22, 5, 7, 16 + frisky.score % 10);
}

void draw_hiscore (void) {
	sp_PrintAtInv (22, 13, 7, 40);
	sp_PrintAtInv (22, 14, 7, 41);
	sp_PrintAtInv (22, 15, 7, 26);
	sp_PrintAtInv (22, 17, 7, 16 + hiscore / 1000);
	sp_PrintAtInv (22, 18, 7, 16 + (hiscore % 1000) / 100);
	sp_PrintAtInv (22, 19, 7, 16 + (hiscore % 100) / 10);
	sp_PrintAtInv (22, 20, 7, 16 + hiscore % 10);
}

void mueve_marifrisky () {
	unsigned char i;
	
	i = sp_JoyKeyboard (&keys);
	
	if ((i & sp_LEFT) == 0) {
		if (frisky.x > 2) {
			frisky.x --;
			/*sp_PrintAtInv (19,     frisky.x, 13, 65);
			sp_PrintAtInv (19, 1 + frisky.x, 15, 66);
			sp_PrintAtInv (19, 2 + frisky.x, 13, 67);*/
			sp_PrintAtInv (19, 3 + frisky.x, 15, 0);
			/*sp_PrintAtInv (20,     frisky.x, 12, 68);
			sp_PrintAtInv (20, 1 + frisky.x, 12, 69);
			sp_PrintAtInv (20, 2 + frisky.x, 12, 70);*/
			sp_PrintAtInv (20, 3 + frisky.x, 15, 0);
		}	
	}
	
	if ((i & sp_RIGHT) == 0) {
		if (frisky.x < 27) {
			sp_PrintAtInv (19,     frisky.x, 15, 0);
			/*sp_PrintAtInv (19, 1 + frisky.x, 13, 65);
			sp_PrintAtInv (19, 2 + frisky.x, 15, 66);
			sp_PrintAtInv (19, 3 + frisky.x, 13, 67);*/
			sp_PrintAtInv (20,     frisky.x, 15, 0);
			/*sp_PrintAtInv (20, 1 + frisky.x, 12, 68);
			sp_PrintAtInv (20, 2 + frisky.x, 12, 69);
			sp_PrintAtInv (20, 3 + frisky.x, 12, 70);*/
			frisky.x ++;
		}
	}
	
	if ((i & sp_FIRE) == 0) {
		if (frisky.status == 0) {
			frisky.status = 1;
			frisky.y = 19;
			frisky.xx = frisky.x + 1;
			#asm
				call PlayPowerPillSFX
			#endasm
		}
	}
	
	if (frisky.status) {
		sp_PrintAtInv (frisky.y, frisky.xx, 15, 0);
		frisky.y --;
		if (frisky.y == 1) {
			frisky.status = 0;
		} else {
			
		}
	}
}

void update_particles () {
	unsigned char i, j;
	unsigned char xx, yy;
	
	// Borro el visil
	
	sp_PrintAtInv (    visil.y,     visil.x, 15, 0);
	sp_PrintAtInv (    visil.y, 1 + visil.x, 15, 0);
	sp_PrintAtInv (1 + visil.y,     visil.x, 15, 0);
	sp_PrintAtInv (1 + visil.y, 1 + visil.x, 15, 0);
	
	// Vamos a mover todas las partculas.
	
	for (i = 0; i < MAX_PARTICLES; i ++) {		
		xx = particulas [i].x >> 3;
		yy = particulas [i].y >> 3;
				
		switch (particulas [i].tipo) {
			case 3:
				// Estrellas tipo 3
				sp_PrintAtInv (yy, xx, 8, 0);
				sp_PrintAtInv (1+yy, xx, 8, 0);
				sp_PrintAtInv (yy, 1+xx, 8, 0);
				sp_PrintAtInv (1+yy, 1+xx, 8, 0);
				particulas [i].y += particulas [i].vy;
				if (particulas [i].y >= 160) {
					particulas [i].y = 16;
					particulas [i].x = (2 + rand () % 27) << 3;
					xx = particulas [i].x >> 3;
				}
				yy = particulas [i].y >> 3;
				sp_PrintAtInv (yy, xx, 13, 81);
				sp_PrintAtInv (1+yy, xx, 13, 82);
				sp_PrintAtInv (yy, 1+xx, 13, 83);
				sp_PrintAtInv (1+yy, 1+xx, 13, 84);
				break;
			case 2:
				// Estrellas tipo 2
				sp_PrintAtInv (yy, xx, 8, 0);
				sp_PrintAtInv (1+yy, xx, 8, 0);
				sp_PrintAtInv (yy, 1+xx, 8, 0);
				sp_PrintAtInv (1+yy, 1+xx, 8, 0);
				particulas [i].y += particulas [i].vy;
				if (particulas [i].y >= 160) {
					particulas [i].y = 16;
					particulas [i].x = (2 + rand () % 27) << 3;
					xx = particulas [i].x >> 3;
				}
				yy = particulas [i].y >> 3;
				sp_PrintAtInv (yy, xx, 15, 78);
				sp_PrintAtInv (1+yy, xx, 15, 79);
				sp_PrintAtInv (yy, 1+xx, 15, 0);
				sp_PrintAtInv (1+yy, 1+xx, 15, 80);
				break;
			case 1:
				// Estrellas tipo 1
				sp_PrintAtInv (yy, xx, 8, 0);
				particulas [i].y += particulas [i].vy;
				if (particulas [i].y >= 168) {
					particulas [i].y = 16;	
					particulas [i].x = (2 + rand () % 28) << 3;
					xx = particulas [i].x >> 3;
				}
				yy = particulas [i].y >> 3;
				sp_PrintAtInv (yy, xx, 14, 75);
				break;			
			case 4:
				//  Malvadoz !!
				sp_PrintAtInv (yy, xx, 10, 77);
				// Colisiones de los malvadoz con el bimbazo de la marifriski:	
				if (yy == frisky.y && xx == frisky.xx) {
					frisky.score += (1 + globaldif);
					draw_score ();
					if (frisky.score > hiscore) {
						hiscore = frisky.score;
						draw_hiscore ();
					}
					// Borro partcula:
					destroy_particle (i);
					// Creo explosioncita:
					add_particle (particulas [i].x, particulas [i].y, 0, 0, 5, 5);
					// Controlo el nmero de partculas:
					frisky.total --;
					// Sonido
					#asm
						call PlayDotSFX
					#endasm
				}
				break;
			case 5:
				// Explosion robotechiana
				switch (particulas [i].vida) {
					case 5:
						sp_PrintAtInv (yy, xx, 15, 85);
						break;
					case 4:
						sp_PrintAtInv (yy, xx, 14, 86);
						break;
					case 3:
						sp_PrintAtInv (yy, xx, 10, 87);
						break;
					case 2:
						sp_PrintAtInv (yy, xx, 11, 88);
						break;
					case 1:
						sp_PrintAtInv (yy, xx, 15, 0);
						break;
					case 0:
						// Suicidio:
						destroy_particle (i);
				}
				particulas [i].vida --;
				break;
		}	
	}
	
	// El Visil:
	
	if (!visil.status) {
		// Esto maneja la frecuencia de lanzamiento del visil dependiendo de la dificultad.
		
		if (globaldif == 9) {
			visil.status = 1;
			visil.x = frisky.x;
			visil.y = 2;	
		} else if (rand () % (18 - globaldif - globaldif) == 0) {
			visil.status = 1;
			visil.x = frisky.x;
			visil.y = 2;
		}
	} else {
		visil.y += 2;
		sp_PrintAtInv (    visil.y,     visil.x, 13, 71);
		sp_PrintAtInv (    visil.y, 1 + visil.x, 13, 72);
		sp_PrintAtInv (1 + visil.y,     visil.x, 13, 73);
		sp_PrintAtInv (1 + visil.y, 1 + visil.x, 15, 74);
		// Hay colisin con nuestro disparino? Esto va a ser bellisimo, vers:
		if (frisky.status && (frisky.y <= visil.y + 1 && frisky.xx >= visil.x && frisky.xx <= visil.x + 1)) {
			// Al carao el visil:
			visil.status = 0;
			frisky.status = 0;
			// Puntos:
			// frisky.score += 5;
			// Ms mierdos:
			if (frisky.total < 32) {
				frisky.total += 3;
				for (i = 0; i < 3; i ++) {
					add_particle ((3 + rand() % 26) <<3, (2 + rand() % 8)<<3, 0, 0, 4, 1);
				}
			}
			// Y cuatro explosiones bellas:
			add_particle ((    visil.x)<<3, (    visil.y)<<3, 0, 0, 5, 5 + (rand() & 3));	
			add_particle ((    visil.x)<<3, (1 + visil.y)<<3, 0, 0, 5, 5 + (rand() & 3));
			add_particle ((1 + visil.x)<<3, (    visil.y)<<3, 0, 0, 5, 5 + (rand() & 3));	
			add_particle ((1 + visil.x)<<3, (1 + visil.y)<<3, 0, 0, 5, 5 + (rand() & 3));	
			// Sonido
			#asm
				call PlayDotSFX
			#endasm
		}
		
		if (visil.y == 18) {
			visil.status = 0;
			// Hay conexin con el malvado visil hasul husuf ben amin?
			if (visil.x >= frisky.x - 1 && visil.x <= frisky.x + 2) {
				// Pataplaf
				sp_UpdateNow ();	// Que se vea, que se vea!
				for (i = 0; i < 4; i ++) {
					kjjjj ();
				}	
				frisky.lives --;
				draw_energy ();
				sp_Border (0);
			}	
		}
	}
	
	// Por tema de capillas... lo dibujo todo aqus.
	
	sp_PrintAtInv (19,     frisky.x, 13, 65);
	sp_PrintAtInv (19, 1 + frisky.x, 15, 66);
	sp_PrintAtInv (19, 2 + frisky.x, 13, 67);
	sp_PrintAtInv (20,     frisky.x, 12, 68);
	sp_PrintAtInv (20, 1 + frisky.x, 12, 69);
	sp_PrintAtInv (20, 2 + frisky.x, 12, 70);
	
	if (frisky.status) {
		sp_PrintAtInv (frisky.y, frisky.xx, 15, 76);
	}
}

void getready () {
	unsigned char i;
	char count;
	
	sp_ClearRect(sp_ClipStruct, 0, 0, sp_CR_TILES); 
	
	sp_PrintAtInv (12, 11, 70, 39); 
	sp_PrintAtInv (12, 12, 70, 37);
	sp_PrintAtInv (12, 13, 70, 52);
	
	sp_PrintAtInv (12, 15, 70, 50);
	sp_PrintAtInv (12, 16, 70, 37);
	sp_PrintAtInv (12, 17, 70, 33);
	sp_PrintAtInv (12, 18, 70, 36);
	sp_PrintAtInv (12, 19, 70, 57);
	sp_PrintAtInv (12, 20, 70, 1);
	
	sp_UpdateNow();
	
	for (count = 3; count >= 0; count --) {
		sp_PrintAtInv (14, 16, 71, 16 + count);
		if (count > 0) {
			#asm
				call PlayDotSFX
			#endasm
		} else {
			#asm
				call PlayPowerPillSFX
			#endasm
		}
		
		sp_UpdateNow();
		
		for (i = 0; i < 50; i ++) {
			#asm
				halt
			#endasm
		}	
	}	
}

char menu () {
	char dif;
	unsigned char i;
	char pressed;
	
	// Devuelve la dificultad elegida.	
	// A los puristas de C: Vern aqu una guarrada
	// de variable global, local y return, 
	// super super feo...
	
	// Est as porque a lo mejor luego cambio una
	// cosa y me viene mejor...
	
	// Aaah! Gente de poca fe...
	
	sp_ClearRect(sp_ClipStruct, 0, 0, sp_CR_TILES); 
	sp_UpdateNow();
	uncrunch (TITLESCR);
	sp_UpdateNow();
	
	sp_PrintAtInv (20, 11, 7, 16);
	sp_PrintAtInv (20, 12, 7, 17);
	sp_PrintAtInv (20, 13, 71, 18);
	sp_PrintAtInv (20, 14, 71, 19);
	sp_PrintAtInv (20, 15, 70, 20);
	sp_PrintAtInv (20, 16, 70, 21);
	sp_PrintAtInv (20, 17, 6, 22);
	sp_PrintAtInv (20, 18, 6, 23);
	sp_PrintAtInv (20, 19, 68, 24);
	sp_PrintAtInv (20, 20, 68, 25);
	
	#asm
		call MUSICA
	#endasm
	
	while ((i & sp_FIRE) == 0){
		i = sp_JoyKeyboard (&keys);
	}
	
	pressed = 0;
	
	do {
		sp_PrintAtInv (19, 11 + globaldif, 6, 0);
		sp_PrintAtInv (21, 11 + globaldif, 6, 0);
		
		i = sp_JoyKeyboard (&keys);
		
		if (!pressed && (i & sp_LEFT) == 0) {
			if (globaldif > 0)
				globaldif --;
				
			#asm
				call PlayDotSFX
			#endasm
			
			pressed = 1;
		} 
		
		if (!pressed && (i & sp_RIGHT) == 0) {
			if (globaldif < 9)
				globaldif ++;
				
			#asm
				call PlayDotSFX
			#endasm
			
			pressed = 1;
		}
		
		if ((i & sp_RIGHT) != 0 && (i & sp_LEFT) != 0)
			pressed = 0;
		
		sp_PrintAtInv (19, 11 + globaldif, 6, 89);
		sp_PrintAtInv (21, 11 + globaldif, 6, 90);
		
		sp_UpdateNow ();
	} while ((i & sp_FIRE) != 0);
	
	dif = globaldif;
	
	return dif;
}

void main (void)
{
	unsigned char j, x, y;
	uchar i;
	char idx;
	unsigned char *wyz_music_flag;
	unsigned char *allpurposepuntero;
	uchar pant;
	uchar playthegame;
	uchar halflife = 0;
	char dif;
	
	uchar flag1, flag2;
	uchar aux;
	
	// Ugly pseudorandom seed using the FRAMES sys var

	/* Substitute BASICs ISR for this thingo: */
	#asm
		di
	#endasm

	sp_InitIM2(0xf1f1);						// Does nothing :)
	sp_CreateGenericISR(0xf1f1);
	sp_RegisterHook(255, musicISR);			// Registramos el hook - Gracias Utopian!

	#asm
		ei
	#endasm

	/* Initialization stuff */

	sp_Initialize (7, 0);
	sp_Border (BLACK);
	sp_AddMemory(0, 50, 14, AD_FREE);		// Allocate for 42 blocks of memory (tight!)
	ps.flags  = sp_PSS_INVALIDATE;
    ps.bounds = sp_ClipStruct;

	/* dummy tiles */

	allpurposepuntero = gfx_tiles;
	for (j = 0; j < 96; j++)
	{
		sp_TileArray (j, allpurposepuntero);
		allpurposepuntero += 8;
	}

	/* Clip structure -- define it as small as possible! */

	spritesClipValues.row_coord = 2;
	spritesClipValues.col_coord = 2;
	spritesClipValues.height = 19;
	spritesClipValues.width = 28;
	spritesClip = &spritesClipValues;

	/* Key assignations */
	
	keys.up    = sp_LookupKey('q');
	keys.down  = sp_LookupKey('a');
	keys.left  = sp_LookupKey('o');
	keys.right = sp_LookupKey('p');
	keys.fire  = sp_LookupKey(' ');
	
	// Empezamos!
	
	while (1) {
		
		// Seleccin de dificultad
		
		dif = menu ();
		
		fade_out ();
		
		// Y ahora el juegapio
		
		flag1 = 0;
		
		frisky.x = 15;
		frisky.status = 0;
		frisky.score = 0;
		frisky.lives = 10;
		frisky.total = 6;

		visil.status = 0;
		visil.x = 15;
		visil.y = 2;
				
		// Al carao todas las partculas.
		
		init_particles ();
		
		// Vamos a colocar unas estrellitas en la pantalla:
		
		for (i = 0; i < n_stars_1 [dif]; i ++) {
			add_particle ((2 + rand() % 27)<<3, (2 + rand() % 17)<<3, 0, 2, 3, 1);
		}
		aux += aux;
		for (i = 0; i < n_stars_2 [dif]; i ++) {
			add_particle ((2 + rand() % 27)<<3, (2 + rand() % 17)<<3, 0, 4, 2, 1);
		}
		aux += aux;
		for (i = 0; i < n_stars_3 [dif]; i ++) {
			add_particle ((2 + rand() % 27)<<3, (2 + rand() % 17)<<3, 0, 8, 1, 1);
		}
		
		// De camino, colocamos tambin a los malvadoz
		for (i = 0; i < 6; i ++) {
			add_particle ((3 + rand() % 26) <<3, (2 + rand() % 8)<<3, 0, 0, 4, 1);
		}
		
		// Empezamos!!
		
		for (i = 0; i < 24; i ++)
			for (j = 0; j < 32; j ++)
				sp_PrintAtInv (i, j, 0, 0);
		
		getready ();
				
		for (i = 0; i < 24; i ++)
			for (j = 0; j < 32; j ++)
				sp_PrintAtInv (i, j, 0, 0);
				
		for (i = 2; i < 21; i ++)
			for (j = 2; j < 30; j ++)
				sp_PrintAtInv (i, j, 15,0);
		
		draw_energy ();
		draw_score ();
		draw_hiscore ();
		
		while (!flag1) {
			sp_UpdateNow ();
			
			mueve_marifrisky ();
			update_particles ();
			
			// Comprobacin de game over...
			if (frisky.lives == 0) 
				flag1 = 1;			
		}
		
		for (i = 11; i < 14; i ++)
			for (j = 11; j < 23; j ++) 
				sp_PrintAtInv (i, j, 7, 0);
				
		sp_PrintAtInv (12, 12, 71, 39);
		sp_PrintAtInv (12, 13, 71, 33);
		sp_PrintAtInv (12, 14, 71, 45);
		sp_PrintAtInv (12, 15, 71, 37);
		sp_PrintAtInv (12, 17, 71, 47);
		sp_PrintAtInv (12, 18, 71, 54);
		sp_PrintAtInv (12, 19, 71, 37);
		sp_PrintAtInv (12, 20, 71, 50);
		sp_PrintAtInv (12, 21, 71, 1);
		
		sp_UpdateNow ();
		
		while ((i & sp_FIRE) == 0){
			i = sp_JoyKeyboard (&keys);
		}
		
		while ((i & sp_FIRE) != 0){
			i = sp_JoyKeyboard (&keys);
		}
		
		fade_out ();
	}		
}

#include "mierda.h"

/*
The Mojon Twins presenta... Shoot Redux: Marifrisky Space Warrior
=================================================================

Un minigame de Kendroock, Anjuel y na_th_an para ZX Spectrum 48

Historia:

Marifrisky se est quedando sin caf. Para evitar la terrible tragedia
que esto podra suponer, debes atravesar el espacio entero para ir a
la tienda de ultramarinos de La Otra Punta, un sistema planetario situado
al otro lado de los dominios del malvado Petruccio Prepuccio, un conocido
mafioso interestelar que vive del trfico de compresas.

Los malvados secuacies de Petruccio, japoneses entrenados en el duro
arte del Kamikazismo, han sido engaados por los marcianos pinreleros,
quienes les han hecho creer que Marifrisky era en realidad la ganadora
del concurso de camisetas mojadas de Venus del ao anterior. Debido a ello,
se lanzan con todo el equipo contra la pobre nave de nuestra herona. Por
suerte para Marifrisky, los misiles pilotados por los secuaces de Petruccio
estn cargaditos de caf, y al reventar se derramar por el espacio.

Ayuda a Marifrisky a conseguir todo el caf que puedas!!

Cmo se juega:

Primero selecciona la dificultad (0->fcil de la hostia, 9->difcil de la
hostia - por tanto: 5->dificultad media de la hostia) usando izquierda y
derecha y pulsando disparo para empezar a jugar.

Bsicamente, tenemos que destruir los piedros coloraos que es donde est
el caf. La forma que tiene Marifrisky de cogerlo no te interesa, y adems
es muy difcil de explicar. Vamos, que lo que t tienes que hacer es
dispararle a los piedros rojos. Y que no te den los misiles. Y si le das
t a un misil con un disparo, ste se romper y saldrn ms piedros rojos.
Y yast.

Teclado:

O izquierda
P derecha
SPACE disparo

Objetivo:

Conseguir muchos puntos y ser la envidia de tus amigos. Adems, si eres
capaz de llegar a la otra punta del universo con tu nave, vers una increble
secuencia final.

Caractersticas:

* enorme mapeado! Tardars 176.893 horas en recorrerlo por completo.
* Increble banda sonora beeper compuesta sin altavoces.
* Sistema FX IATE (Inteligencia Artificial Terrblemente Enervante).
* Vestuario de Marifrisky provisto por Zango y Mara.
* Sistema de control inteligente simplificado de 3 botones.
* Increble factor QCHJAE (Qu Coo Hago Jugando a Esto).
* No te pierdas el increble efecto multicolor en gigascreen 
  cuando te llegues al final del juego!
  
  */
  
  